

#include "config.h"
/*
#define LOW_PWM	//__
#define LOTOK_ONE_SW	//   
#define REVERS_RELE		//    
#define katod//    .   
*/

//#define TIME_ON_VLAG	150	// .  

#if defined(LOTOK_ONE_SW)
#warning ONE_SWT_
#elif defined(AKTUATOR)
#warning AKTUATOR	
#else
#warning     	
#endif

#ifdef LOW_PWM
#warning LPWM_
#else
#warning FI_	
#endif

#ifndef AKTUATOR
	#ifdef REVERS_RELE
	#warning RELE_
	#else
	#warning VT_	
	#endif
#endif

#ifdef katod
#warning OK
#else
#warning OA	
#endif


//--------------------------------
#define BTN_TEMPER		_BV(1) 	//
#define BTN_TIME_OFF	_BV(3)  //PLUS   
#define BTN_DS2			_BV(2)  //MINUS  . 
#define SWT_L_KONZEVIK	_BV(4) 
#define SWT_R_KONZEVIK	_BV(5) 

//---------PORTB-PORTC---------
#define PINLED	PINB
#define PORTLED	PORTB
#define	DDRLED	DDRB
#define	PORTZN	PORTC
#define DDRZN	DDRC
#define PINZN	PINC
#define	ZN0		_BV(2)
#define	ZN1		_BV(3)
#define	ZN2		_BV(4)
#define	BITZN	(ZN0|ZN1|ZN2)

#define	PORT_SEG_GH	PORTC
#define	DDR_SEG_GH	DDRC
#define	SEG_G		_BV(0)
#define	SEG_H		_BV(1)
#define SEG_GH	(SEG_G|SEG_H)

//------------PORTD-------------
#define PORT_OUT			PORTD
#define DDR_OUT				DDRD

#define OUT_TRIAC			_BV(3)
#define OUT_ALARM			_BV(6)
#define OUT_ALARM_2			_BV(5)
#define INDIKATION_ALARM	_BV(7)
#define OUT_ON_NAGREV		_BV(4)
#define OUT_MOTOR			_BV(0)
#define OUT_MOTOR_REVERS	_BV(1)

#define OUT_PIN	(OUT_TRIAC|OUT_ALARM|INDIKATION_ALARM|OUT_ON_NAGREV|OUT_ALARM_2|OUT_MOTOR|OUT_MOTOR_REVERS)

//------------PORTC-------------
#define OUT_VLAG	_BV(5)
#define DDR_VLAG	DDRC
#define PORT_VLAG	PORTC

//-----------DS18B20------------
#define	PORT_1wire	PORTB
#define	DDR_1wire	DDRB
#define	PIN_1wire	PINB
#define	PWIRE_0 		_BV(6)	// DQ DS18B20
#define	PWIRE_1 		_BV(7)	// DQ DS18B20
//-----------------------------

//#define TIME_T1(tim)	(  ( tim/(1/F_CPU*64) ) )
#define TIME_T1(tim)	( (uint16_t)  ( tim/6.4e-5 ) )

#define sA	0x01
#define sB	0x02
#define sC	0x04
#define sD	0x08
#define sE	0x10
#define sF	0x20
#define sG	0x40
#define sH	0x80
/*		 -A-
		F	B
		 -G-
		E	C
		 -D-	*/
const uint8_t font[]={
sA|sB|sC|sD|sE|sF,//0
sB|sC,//1
sA|sB|sG|sE|sD,//2
sA|sB|sG|sC|sD,//3
sF|sG|sB|sC,//4
sA|sF|sG|sC|sD,//5
sA|sF|sG|sC|sD|sE,//6
sA|sB|sC,//7
sA|sB|sC|sD|sE|sF|sG,//8
sA|sB|sC|sD|sG|sF,//9
sA|sD|sE|sF|sG,//E
sD|sE|sF|sG,//t
sB|sC|sD|sE|sG,//d
sA|sB|sC|sE|sF|sG,//A
sA|sB|sE|sF|sG,//P
sB|sC|sD|sF|sG,//
sA|sD|sE|sF,//C
sA|sE|sF|sG,//F
sC|sE|sG,//n
sF|sE|sD|sC|sB,//U
sC|sD|sE|sG,//o
};

#define f_e	10
#define f_t	11
#define f_d	12
#define f_a	13
#define f_P	14
#define f_y 15
#define f_C 16
#define f_F 17
#define f_n 18
#define f_U 19
#define f_o 20

prog_int8_t osccal=0xFF;

static uint8_t		led_buffer[3], znmesto, state_wire, power, power_flag, tmp_power=1,
				state, time_blank, alarm_T, time_alarm, status_nagrev,
				out_1wire, temperature[4], time_wire, 
				bcd_num2,bcd_num3,bcd_num4,
				eeprom_err, 
				swt_konzevik, key,  inc, show_vlagnost, on_out_vlagnost, Vlagnost,   
				antdr, count_press, povtor, blank,
				revers, state_motor, time_state;
int32_t Time_Motor;

uint16_t porog=(uint16_t)(35*16), tmp_uint16, Temperatura, Old_Temperatura, T_jmp=130*16, Temp_DS2;
int16_t tmp_int16, time_vlagnost;

#define Tim_Pause(tim)	( (tim/0.004)+1 ) 
const uint8_t pause_after_press[]={Tim_Pause(0.55), Tim_Pause(0.5), Tim_Pause(0.41), Tim_Pause(0.33), Tim_Pause(0.25), Tim_Pause(0.20), Tim_Pause(0.15), Tim_Pause(0.1)}; 

struct	setup{
		int16_t correction_ds0;
		int16_t correction_ds1;
		uint16_t porog;
		uint16_t AlarmT;
		uint16_t vlagnost;
		int16_t time_lotok_pause;
		int16_t time_lotok_on;
		int16_t TimeOnVlagnost;
		int16_t TimePauseVlagnost;
		uint16_t crc;
} setup;


	
enum {ST_0=0, ST_INPUT_REG, 
ST_SET_T, ST_SET_T_1,ST_SET_T_ALARM,ST_SET_T_ALARM_1, 
ST_FORCE_POVOROT, ST_MANUAL_MOVE, ST_MANUAL_MOVE_1, ST_MANUAL_MOVE_2,
ST_TIM_OFF, ST_TIM_OFF_1, 
ST_SET_VLAG, ST_SET_VLAG_POROG, ST_SET_VLAG_T_ON, ST_SET_VLAG_T_ON_1, ST_SET_VLAG_PAUSE, ST_SET_VLAG_PAUSE_1,
ST_COR, ST_COR_1, ST_COR_2, ST_COR_IN_DS2,
ST_SHOW_VLAGNOST,
ST_STORE_EEP};


//-------------EEPROM-----------------
#define ADR_EEP		10
//------------------------------------

//static uint8_t antdr_swt=0;
